## casacore 3.6.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.3.0)

project(casacore VERSION 3.6.1)

include(CheckCXXCompilerFlag)
include(CheckCCompilerFlag)
include(CheckFunctionExists)
include(CheckCXXSourceCompiles)
include(cmake/PCHSupport.cmake)

# Fixes warnings on cmake 3.x+ about missing extensions
if (POLICY CMP0115)
    cmake_policy (SET CMP0115 NEW)
endif()

# Enable <packageName>_ROOT variables for recent versions of CMake
if (POLICY CMP0074)
    cmake_policy (SET CMP0074 NEW)
endif()

# Increment the PROJECT_SOVERSION every time you update VERSION_MINOR!
SET(PROJECT_SOVERSION 8)

SET(NO_SOVERSION FALSE CACHE BOOL "do not add version information to shared libraries")
set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

set(CPACK_GENERATOR "DEB")
set(CPACK_PACKAGE_NAME "casacore")
set(CPACK_PACKAGE_VERSION "${PROJECT_VERSION}")

set(CPACK_PACKAGE_CONTACT "Malte Marquarding") #required
set(CPACK_PACKAGE_VENDOR "https://github.com/casacore/casacore")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Astronomical data processing library")

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# By default build only Python3 bindings
option (BUILD_PYTHON "Build the python2 bindings" NO)
option (BUILD_PYTHON3 "Build the python3 bindings" YES)

option (BUILD_DEPRECATED "build and install deprecated classes (such as Map)" NO)
option (BUILD_FFTPACK_DEPRECATED "build FFTPack" NO)
option (BUILD_DYSCO "Build the Dysco compression storage manager" YES)

# By default build shared libraries
option (ENABLE_SHARED "Build shared libraries" YES)
option (ENABLE_RPATH "Include rpath in executables and shared libraries" YES)

# Check if O_DIRECT is available.
# Note this does not work well with check_c_source_compiles.
check_cxx_source_compiles("
  #include <fcntl.h>
  main() { int i = O_DIRECT; }
  " HAVE_O_DIRECT)
if (HAVE_O_DIRECT)
    add_definitions(-DHAVE_O_DIRECT)
endif()

# By default do not use ADIOS2, HDF5
option (ENABLE_TABLELOCKING "Make locking for concurrent table access possible" YES)
option (USE_READLINE "Build readline support" YES)
option (USE_ADIOS2 "Build ADIOS2 " NO)
option (USE_HDF5 "Build HDF5 " NO)
option (USE_THREADS "Use Mutex thread synchronization" YES)
option (USE_OPENMP "Use OpenMP threading" NO)
option (USE_MPI "Use MPI for parallel IO" NO)
option (USE_STACKTRACE "Show stacktrace in case of exception" NO)
option (CASA_BUILD "Building in the CASA (http://casa.nrao.edu) environment" NO)

set(CASA_DEFAULT_ALIGNMENT "32" CACHE STRING "Default alignment of casa::AlignedAllocator")

# ccache use is optional
option( UseCcache OFF )

if (UseCcache)
    message (STATUS "Searching for ccache.")
    find_program(CCACHE_FOUND ccache)
    if(CCACHE_FOUND)
        message (STATUS "Ccache found.")
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
    endif(CCACHE_FOUND)
endif()


# basic setup for building within CASA environment
if( CASA_BUILD )
   if( NOT DATA_DIR )
      set(DATA_DIR "%CASAROOT%/data")
   endif( )
   set(USE_OPENMP ON)
   set(USE_THREADS ON)
   set(BUILD_FFTPACK_DEPRECATED ON)
   set(BUILD_PYTHON OFF)
   set(Boost_NO_BOOST_CMAKE 1)
   if (EXISTS "/opt/casa/02/include/python2.7")
      ### RHEL7
      set(PYTHON_LIBRARY "/opt/casa/02/lib/libpython2.7.so")
      set(PYTHON_INCLUDE_DIR "/opt/casa/02/include/python2.7")
      set(NUMPY_INCLUDE_DIRS "/opt/casa/02/lib/python2.7/site-packages/numpy/core/include")
      set(PYTHON_EXECUTABLE:FILEPATH "/opt/casa/02/bin/python")
      if (EXISTS "/usr/include/boost")
         set(BOOST_ROOT "/usr")
      endif( )
      set(WCSLIB_INCLUDE_DIR "/opt/casa/02/include")
      set(WCSLIB_LIBRARY "/opt/casa/02/lib/libwcs.so")
      set(PYTHON2_NUMPY_INCLUDE_DIRS "/opt/casa/02/lib/python2.7/site-packages/numpy/core/include")
   elseif (EXISTS "/opt/casa/01/include/python2.7")
      ### RHEL7
      set(PYTHON_LIBRARY "/opt/casa/01/lib/libpython2.7.so")
      set(PYTHON_INCLUDE_DIR "/opt/casa/01/include/python2.7")
      set(PYTHON_EXECUTABLE:FILEPATH "/opt/casa/01/bin/python")
      if (EXISTS "/usr/include/boost")
         set(BOOST_ROOT "/usr")
      endif( )
   elseif(EXISTS "/usr/lib64/casa/01/include/python2.7")
      ### RHEL5/RHEL6
      set(PYTHON_LIBRARY "/usr/lib64/casa/01/lib/libpython2.7.so")
      set(PYTHON_INCLUDE_DIR "/usr/lib64/casa/01/include/python2.7")
      set(PYTHON_EXECUTABLE:FILEPATH "/usr/lib64/casa/01/bin/python")
      if (EXISTS "/usr/lib64/casa/01/include/boost")
         ### RHEL5
         set(BOOST_ROOT "/usr/lib64/casa/01")
      elseif (EXISTS "/usr/include/boost")
         ### RHEL6
         set(BOOST_ROOT="/usr")
      endif( )
   endif( )
endif( )

# Test if shared libraries have to be built.
if (ENABLE_SHARED)
    option (BUILD_SHARED_LIBS "" YES)
    if (ENABLE_RPATH)
        # Set RPATH to use for installed targets; append linker search path
        set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib" )
        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
        set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
        set(CMAKE_MACOSX_RPATH TRUE)
    endif (ENABLE_RPATH)
	if( CASA_BUILD )
		option(NO_SOVERSION "Build shared libraries without version information" NO)
		if( NOT NO_SOVERSION )
			set( epochdelta 1385614800 )
			execute_process( COMMAND perl -e "$t=time( )-${epochdelta};$z=$t & 0xff; $y=($t>>8)&0xff; $x=($t>>16)&0xffff; print \"$x.$y.$z\""
					         OUTPUT_VARIABLE __casa_soversion )
			set(casa_soversion ${__casa_soversion} CACHE STRING "version for shared objects")
			message( STATUS "Shared object version number ${casa_soversion}" )
			file( WRITE ${CMAKE_INSTALL_PREFIX}/casa_sover.txt
				  "# generated by casacore/CMakeList.txt... Do not edit\n"
				  "${casa_soversion}\n" )
		else( )
			message( STATUS "User disabled shared library versioning" )
		endif( )
	endif( )
else()
    option (BUILD_SHARED_LIBS "" NO)
endif (ENABLE_SHARED)

if (UseCasaNamespace)
    add_definitions (-DUseCasaNamespace)
    message (STATUS "Using namespace casa. This will be deprecated at some point.")
else ()
    message (STATUS "Using namespace casacore.")
endif ()

# Define the compiler flags to be used.
# Note: -Wshadow and -Wunreachable-code give (too) many warnings.
# Casacore uses longlong, so no warnings for it.
# Clang gives warning on bison generated code; disable unneeded-internal-declaration.
if (NOT CMAKE_CXX_FLAGS)
    set (CMAKE_CXX_FLAGS "-Wextra -Wall -W -Wpointer-arith -Woverloaded-virtual -Wwrite-strings -pedantic -Wno-long-long")
#SET(CMAKE_CXX_FLAGS="-g -O0 -Wall -Wextra -Wshadow -Wunused-variable
# -Wunused-parameter -Wunused-function -Wunused -Wno-system-headers
# -Wno-deprecated -Woverloaded-virtual -Wwrite-strings -fprofile-arcs
# -ftest-coverage -Wold-style-cast -Weffc++ -Wconversion")
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unneeded-internal-declaration")
    endif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
endif (NOT CMAKE_CXX_FLAGS)

# Set build type if not given.
if (NOT CMAKE_BUILD_TYPE)
    # Use debug mode if building in dbg or debug directory.
    get_filename_component(_cmpvar ${CMAKE_BINARY_DIR} NAME)
    if(_cmpvar STREQUAL "dbg" OR _cmpvar STREQUAL "debug")
        set (CMAKE_BUILD_TYPE Debug)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DAIPS_DEBUG")
    else()
        if(_cmpvar STREQUAL "cov")
            set (CMAKE_BUILD_TYPE Debug)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -O0 --coverage")
            set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} --coverage")
        else()
            set (CMAKE_BUILD_TYPE Release)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNDEBUG")
        endif(_cmpvar STREQUAL "cov")
    endif(_cmpvar STREQUAL "dbg" OR _cmpvar STREQUAL "debug")
endif (NOT CMAKE_BUILD_TYPE)

# Require a C++11 compatible compiler
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Ensure clang is not complaining about unused arguments.
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "-Qunused-arguments ${CMAKE_CXX_FLAGS}")
    set(CMAKE_C_FLAGS "-Qunused-arguments ${CMAKE_C_FLAGS}")
endif()

# Since 2015, we need pread and pwrite (POSIX 2001)
check_function_exists(pread HAVE_PREAD)
check_function_exists(pwrite HAVE_PWRITE)
if (NOT (HAVE_PREAD AND HAVE_PWRITE))
        message(FATAL_ERROR "Casacore requires pread and pwrite functionality" )
endif (NOT (HAVE_PREAD AND HAVE_PWRITE))

# Since 2020, we need GCC 4.9 for regex support
# Additionally we need cmake 2.8.10 for CMAKE_CXX_COMPILER_VERSION
if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.9)
    message(FATAL_ERROR "Casacore requires at least gcc-4.9")
endif()

# FindHDF5 uses environment variables, so set it if needed.
if (HDF5_ROOT_DIR)
    set (ENV{HDF5_ROOT} ${HDF5_ROOT_DIR})
endif (HDF5_ROOT_DIR)

# Find out which modules to build.
if (NOT MODULE)
   set (MODULE all)
endif (NOT MODULE)
set (_usebison NO)
set (_uselapack NO)
set (_usefortran NO)
set (_usefits NO)
set (_usewcs NO)
set (_modules casa)
set (_modules2 )
if (NOT ${MODULE} STREQUAL "casa")
    set (_modules ${_modules} tables)
    set (_usebison YES)
    if (NOT ${MODULE} STREQUAL "tables")
        set (_modules ${_modules} scimath_f scimath measures meas)
        set (_uselapack YES)
        set (_usefortran YES)
        if (NOT ${MODULE} STREQUAL "measures")
            if (${MODULE} STREQUAL "ms")
                set (_modules ${_modules} ms derivedmscal)
            endif()
            if (${MODULE} STREQUAL "msfits" OR ${MODULE} STREQUAL "all")
                set (_modules2 ${_modules2} ms msfits derivedmscal)
                set (_usefits YES)
            endif()
            if (${MODULE} STREQUAL "images" OR ${MODULE} STREQUAL "all")
                set (_modules2 ${_modules2} lattices mirlib coordinates images)
                set (_usewcs YES)
                set (_usefits YES)
            endif()
        endif()
    endif()
endif()

if (_usefits)
    set (_modules ${_modules} fits)
endif()
set (_modules ${_modules} ${_modules2})

if (BUILD_PYTHON)
    set (_modules ${_modules} python)
endif (BUILD_PYTHON)

if (BUILD_PYTHON3)
    set (_modules ${_modules} python3)
endif (BUILD_PYTHON3)


# Determine which external packages to use.
include (CTest)

if (_usefortran)
  enable_language (Fortran)

  # use faster fortran rules for complex operations, removes restoring complex
  # infinities if naive computation results in NAN + NAN * I
  #Handling complex multiplication and division with correct treating of complex
  #infinities (one element Inf regardless of the other) according to the C is
  #complicated.
  #E.g. a = NaN + 1e30 i; a * a is not NaN but a complex infinity (-Inf - NaN).
  #
  #Treating this situation correctly has large performance impact. In GCC's
  #implementation it is about 4 times slower than the naive implementation, with
  #vectorization enabled the impact is even larger.
  #As correct treatment of complex infinities when NaN appear in results is seldom
  #accounted for, or not required and most other languages do not have these
  #rules, the correct treatmeant can be disabled with the -fcx-fortran-rules flag.
  #This changes the semantics to those of the FORTRAN language which is removes
  #the need for rescuing the result when NaN appear. Python also follows FORTRAN
  #rules.
  #Additionally the correct behavior is not implemented in all compilers,
  #most notably clang which is the default compiler on MacOS. So turning off
  #correct treatment with GCC does not only make our code faster but also behave
  #the same on more compilers.
  #
  #This has measurable impact on e.g. applycal where the cpu performance improves
  #by about 20%.
  # For one reason or another the check on the compiler flag has no
  # effect; it still adds the option which fails for clang.
  if (NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
      check_cxx_compiler_flag(-fcx-fortran-rules HAS_GXX_FORTRAN_RULES)

=== casa/CMakeLists.txt ===
#
# CASA casa
#

configure_file (
  config.h.in
  "${PROJECT_BINARY_DIR}/casacore/casa/config.h"
  @ONLY)
configure_file (
  version.h.in
  "${PROJECT_BINARY_DIR}/casacore/casa/version.h"
  @ONLY)

set (
parser_inputs
JsonGram
)
 
foreach (src ${parser_inputs})
    if (BISON_VERSION VERSION_LESS 3.0)
        BISON_TARGET (${src} Json/${src}.yy ${CMAKE_CURRENT_BINARY_DIR}/${src}.ycc COMPILE_FLAGS "-y -p ${src}")
    else()
        BISON_TARGET (${src} Json/${src}.yy ${CMAKE_CURRENT_BINARY_DIR}/${src}.ycc COMPILE_FLAGS "-y -Dapi.prefix={${src}} --warnings=no-yacc")
    endif()
    FLEX_TARGET (${src} Json/${src}.ll ${CMAKE_CURRENT_BINARY_DIR}/${src}.lcc COMPILE_FLAGS "-P${src}")
endforeach (src)

include_directories (${CMAKE_CURRENT_BINARY_DIR})


# Define the bfiles to build.
set (buildfiles
Arrays/ArrayBase.cc
Arrays/ArrayError.cc
Arrays/ArrayOpsDiffShapes.cc
Arrays/ArrayPartMath.cc
Arrays/ArrayPosIter.cc
Arrays/ArrayUtil2.cc
Arrays/Array2.cc
Arrays/Array2Math.cc
Arrays/Array_tmpl.cc
Arrays/AxesMapping.cc
Arrays/AxesSpecifier.cc
Arrays/ExtendSpecifier.cc
Arrays/IPosition.cc
#Arrays/IPosition2.cc
Arrays/MaskArrMath2.cc
Arrays/Matrix2Math.cc
Arrays/Matrix_tmpl.cc
Arrays/Slice.cc
Arrays/Slicer.cc
Arrays/Vector_tmpl.cc
BasicMath/Math.cc
BasicMath/Primes.cc
BasicMath/Random.cc
BasicSL/Complex.cc
BasicSL/Constants.cc
BasicSL/IComplex.cc
BasicSL/STLMath.cc
BasicSL/String.cc
Containers/Allocator.cc
Containers/Block.cc
Containers/Block_tmpl.cc
Containers/IterError.cc
Containers/Record.cc
Containers/RecordDesc.cc
Containers/RecordDescRep.cc
Containers/RecordFieldId.cc
Containers/RecordField2Writer.cc
Containers/RecordInterface.cc
Containers/RecordRep.cc
Containers/Record2.cc
Containers/Record2Interface.cc
Containers/ValueHolder.cc
Containers/ValueHolderRep.cc
Exceptions/Error2.cc
Exceptions/CasaErrorTools.cc
HDF5/HDF5DataSet.cc
HDF5/HDF5DataType.cc
HDF5/HDF5Error.cc
HDF5/HDF5File.cc
HDF5/HDF5Group.cc
HDF5/HDF5HidMeta.cc
HDF5/HDF5Object.cc
HDF5/HDF5Record.cc
Inputs/Input.cc
Inputs/Param.cc
IO/AipsIO.cc
IO/BaseSinkSource.cc
IO/BucketBase.cc
IO/BucketBuffered.cc
IO/BucketCache.cc
IO/BucketFile.cc
IO/BucketMapped.cc
IO/ByteIO.cc
IO/ByteSink.cc
IO/ByteSinkSource.cc
IO/ByteSource.cc
IO/CanonicalIO.cc
IO/ConversionIO.cc
IO/FilebufIO.cc
IO/FiledesIO.cc
IO/FileLocker.cc
IO/FileUnbufferedIO.cc
IO/IPositionIO.cc
IO/LECanonicalIO.cc
IO/LockFile.cc
IO/MemoryIO.cc
IO/MFFileIO.cc
IO/MMapfdIO.cc
IO/MMapIO.cc
IO/MultiFile.cc
IO/MultiFileBase.cc
IO/MultiHDF5.cc
IO/RawIO.cc
IO/RegularFileIO.cc
IO/StreamIO.cc
IO/TapeIO.cc
IO/TypeIO.cc
Json/JsonError.cc
Json/JsonKVMap.cc
Json/JsonOut.cc
Json/JsonParser.cc
Json/JsonValue.cc
Logging/LogFilter.cc
Logging/LogFilterInterface.cc
Logging/LogIO.cc
Logging/LogMessage.cc
Logging/LogOrigin.cc
Logging/LogSink.cc
Logging/LogSinkInterface.cc
Logging/MemoryLogSink.cc
Logging/NullLogSink.cc
Logging/StreamLogSink.cc
OS/CanonicalConversion.cc
OS/CanonicalDataConversion.cc
OS/Conversion.cc
OS/DataConversion.cc
OS/Directory.cc
OS/DirectoryIterator.cc
OS/DOos.cc
OS/DynLib.cc
OS/EnvVar.cc
OS/File.cc
OS/HostInfo.cc
OS/IBMConversion.cc
OS/IBMDataConversion.cc
OS/MemoryTrace.cc
OS/LECanonicalConversion.cc
OS/LECanonicalDataConversion.cc
OS/LittleEndianConversion.cc
OS/malloc.cc
OS/Memory.cc
OS/MemoryTrace.cc
OS/ModcompConversion.cc
OS/ModcompDataConversion.cc
OS/OMP.cc
OS/Path.cc
OS/PrecTimer.cc
OS/RawDataConversion.cc
OS/RegularFile.cc
OS/SymLink.cc
OS/Time.cc
OS/Timer.cc
OS/VAXConversion.cc
OS/VAXDataConversion.cc
Quanta/Euler.cc
Quanta/MeasValue.cc
Quanta/MVAngle.cc
Quanta/MVBaseline.cc
Quanta/MVDirection.cc
Quanta/MVDoppler.cc
Quanta/MVDouble.cc
Quanta/MVEarthMagnetic.cc
Quanta/MVEpoch.cc
Quanta/MVFrequency.cc
Quanta/MVPosition.cc
Quanta/MVRadialVelocity.cc
Quanta/MVTime.cc
Quanta/MVuvw.cc
Quanta/QBase.cc
Quanta/QC.cc
Quanta/QLogical2.cc
Quanta/QMath2.cc
Quanta/QuantumHolder.cc
Quanta/Quantum2.cc
Quanta/RotMatrix.cc
Quanta/Unit.cc
Quanta/UnitDim.cc
Quanta/UnitMap.cc
Quanta/UnitMap2.cc
Quanta/UnitMap3.cc
Quanta/UnitMap4.cc
Quanta/UnitMap5.cc
Quanta/UnitMap6.cc
Quanta/UnitMap7.cc
Quanta/UnitName.cc
Quanta/UnitVal.cc
System/Aipsrc.cc
System/AipsrcBool.cc
System/AipsrcValue2.cc
System/AipsrcVBool.cc
System/AipsrcVString.cc
System/AppInfo.cc
System/AppState.cc
System/Casarc.cc
System/Choice.cc
System/ObjectID.cc
System/ObjectID2.cc
System/PGPlotter.cc
System/PGPlotterInterface.cc
System/PGPlotterNull.cc
System/ProgressMeter.cc
Utilities/BitVector.cc
Utilities/CountedPtr2.cc
Utilities/Compare.cc
Utilities/CompositeNumber.cc
Utilities/Copy2.cc
Utilities/DataType.cc
Utilities/DynBuffer.cc
Utilities/Fallible2.cc
Utilities/MUString.cc
Utilities/Precision.cc
Utilities/RecordTransformable.cc
Utilities/Regex.cc
Utilities/Sequence2.cc
Utilities/Sort.cc
Utilities/SortError.cc
Utilities/StringDistance.cc
Utilities/ValType.cc
aips.cc
version.cc
${BISON_JsonGram_OUTPUTS}
${FLEX_JsonGram_OUTPUTS}
)

set(top_level_headers
${PROJECT_BINARY_DIR}/casacore/casa/config.h
aipsdef.h
aipsenv.h
aips.h
aipstype.h
aipsxtype.h
Arrays.h
BasicMath.h
BasicSL.h
complex.h
Containers.h
Exceptions.h
fstream.h
HDF5.h
Inputs.h
IO.h
iomanip.h
iosfwd.h
iosstrfwd.h
iostream.h
istream.h
Json.h
Logging.h
math.h
namespace.h
OS.h
ostream.h
Quanta.h
sstream.h
stdexcept.h
stdio.h
stdlib.h
stdmap.h
stdvector.h
string.h
System.h
typeinfo.h
Utilities.h
vector.h
${PROJECT_BINARY_DIR}/casacore/casa/version.h
)

add_library (casa_casa ${buildfiles})
init_pch_support(casa_casa ${top_level_headers})


if (HDF5_FOUND)
    list (APPEND de_libraries ${HDF5_LIBRARIES})
endif (HDF5_FOUND)
if (READLINE_FOUND)
    list (APPEND de_libraries ${READLINE_LIBRARIES})
endif (READLINE_FOUND)

find_library(libm m)

target_link_libraries (
casa_casa
${de_libraries}
${libm}
dl
${CASACORE_ARCH_LIBS}
)

add_subdirectory (apps)

install (
TARGETS casa_casa
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Arrays/ArrayAccessor.h
Arrays/ArrayBase.h
Arrays/ArrayError.h
Arrays/Array.h
Arrays/Array.tcc
Arrays/ArrayFwd.h
Arrays/ArrayIter.h
Arrays/ArrayIter.tcc
Arrays/ArrayLogical.h
Arrays/ArrayLogical.tcc
Arrays/ArrayMathBase.h
Arrays/ArrayMath.h
Arrays/ArrayMath.tcc
Arrays/ArrayOpsDiffShapes.h
Arrays/ArrayOpsDiffShapes.tcc
Arrays/ArrayPartMath.h
Arrays/ArrayPartMath.tcc
Arrays/ArrayPosIter.h
Arrays/ArrayStr.h
Arrays/ArrayStr.tcc
Arrays/ArrayUtil.h
Arrays/ArrayUtil.tcc
Arrays/AxesMapping.h
Arrays/AxesSpecifier.h
Arrays/Cube.h
Arrays/Cube.tcc
Arrays/ElementFunctions.h
Arrays/ExtendSpecifier.h
Arrays/IPosition.h
Arrays/LogiArray.h
Arrays/LogiCube.h
Arrays/LogiMatrix.h
Arrays/LogiVector.h
Arrays/MaskArrIO.h
Arrays/MaskArrIO.tcc
Arrays/MaskArrLogi.h
Arrays/MaskArrLogi.tcc
Arrays/MaskArrMath.h
Arrays/MaskArrMath.tcc
Arrays/MaskedArray.h
Arrays/MaskedArray.tcc
Arrays/MaskLogiArrFwd.h
Arrays/MaskLogiArr.h
Arrays/Matrix.h
Arrays/Matrix.tcc
Arrays/MatrixIter.h
Arrays/MatrixIter.tcc
Arrays/MatrixMath.h
Arrays/MatrixMath.tcc
Arrays/Memory.h
Arrays/Slice.h
Arrays/Slicer.h
Arrays/Storage.h
Arrays/Vector.h
Arrays/Vector.tcc
Arrays/Vector2.tcc
Arrays/VectorIter.h
Arrays/VectorIter.tcc
Arrays/VectorSTLIterator.h
DESTINATION include/casacore/casa/Arrays
)

install (FILES
BasicMath/ConvertScalar.h
BasicMath/Functional.h
BasicMath/Functional.tcc
BasicMath/Functors.h
BasicMath/Math.h
BasicMath/Primes.h
BasicMath/Random.h
BasicMath/StdLogical.h
DESTINATION include/casacore/casa/BasicMath
)

install (FILES
BasicSL/Complexfwd.h
BasicSL/Complex.h
BasicSL/Constants.h
BasicSL/IComplex.h
BasicSL/String.h
BasicSL/STLMath.h
BasicSL/STLIO.h
BasicSL/STLIO.tcc
DESTINATION include/casacore/casa/BasicSL
)

install (FILES
Containers/Allocator.h
Containers/Block.h
Containers/BlockIO.h
Containers/BlockIO.tcc
Containers/IterError.h
Containers/ObjectStack.h
Containers/ObjectStack.tcc
Containers/RecordDesc.h
Containers/RecordDescRep.h
Containers/RecordField.h
Containers/RecordField.tcc
Containers/RecordFieldId.h
Containers/RecordFieldWriter.h
Containers/RecordFieldWriter.tcc
Containers/Record.h
Containers/RecordInterface.h
Containers/RecordRep.h
Containers/ValueHolder.h
Containers/ValueHolderRep.h
DESTINATION include/casacore/casa/Containers
)

install (FILES
Exceptions/CasaErrorTools.h
Exceptions/Error.h
Exceptions/Error.tcc
DESTINATION include/casacore/casa/Exceptions
)

install (FILES
HDF5/HDF5DataSet.h
HDF5/HDF5DataType.h
HDF5/HDF5Error.h
HDF5/HDF5File.h
HDF5/HDF5Group.h
HDF5/HDF5HidMeta.h
HDF5/HDF5Object.h
HDF5/HDF5Record.h
DESTINATION include/casacore/casa/HDF5
)

install (FILES
Inputs/Input.h
Inputs/Param.h
DESTINATION include/casacore/casa/Inputs
)

install (FILES
IO/AipsIOCarray.h
IO/AipsIOCarray.tcc
IO/AipsIO.h
IO/ArrayIO.h
IO/ArrayIO.tcc
IO/BaseSinkSource.h
IO/BucketBase.h
IO/BucketBuffered.h
IO/BucketCache.h
IO/BucketFile.h
IO/BucketMapped.h
IO/ByteIO.h
IO/ByteSink.h
IO/ByteSinkSource.h
IO/ByteSource.h
IO/CanonicalIO.h
IO/ConversionIO.h
IO/FilebufIO.h
IO/FiledesIO.h
IO/FileLocker.h
IO/FileUnbufferedIO.h
IO/LargeIOFuncDef.h
IO/LECanonicalIO.h
IO/LockFile.h
IO/MemoryIO.h
IO/MFFileIO.h
IO/MMapfdIO.h
IO/MMapIO.h
IO/MultiFile.h
IO/MultiFileBase.h
IO/MultiHDF5.h
IO/RawIO.h
IO/RegularFileIO.h
IO/StreamIO.h
IO/TapeIO.h
IO/TypeIO.h
DESTINATION include/casacore/casa/IO
)

install (FILES
Json/JsonError.h
Json/JsonKVMap.h
Json/JsonOut.h
Json/JsonOut.tcc
Json/JsonParser.h
Json/JsonValue.h
DESTINATION include/casacore/casa/Json
)

install (FILES
Logging/LogFilter.h
Logging/LogFilterInterface.h
Logging/LogIO.h
Logging/LogMessage.h
Logging/LogOrigin.h
Logging/LogSink.h
Logging/LogSinkInterface.h
Logging/MemoryLogSink.h
Logging/NullLogSink.h
Logging/StreamLogSink.h
DESTINATION include/casacore/casa/Logging
)

install (FILES
OS/CanonicalConversion.h
OS/CanonicalDataConversion.h
OS/Conversion.h
OS/DataConversion.h
OS/Directory.h
OS/DirectoryIterator.h
OS/DOos.h
OS/DynLib.h
OS/EnvVar.h
OS/File.h
OS/HostInfoBsd.h
OS/HostInfoDarwin.h
OS/HostInfo.h
OS/HostInfoHpux.h
OS/HostInfoIrix.h
OS/HostInfoLinux.h
OS/HostInfoOsf1.h
OS/HostInfoSolaris.h
OS/IBMConversion.h
OS/IBMDataConversion.h
OS/LECanonicalConversion.h
OS/LECanonicalDataConversion.h
OS/LittleEndianConversion.h
OS/malloc.h
OS/Memory.h
OS/MemoryTrace.h
OS/ModcompConversion.h
OS/ModcompDataConversion.h
OS/Mutex.h
OS/OMP.h
OS/Path.h
OS/PrecTimer.h
OS/RawDataConversion.h
OS/RegularFile.h
OS/SymLink.h
OS/Time.h
OS/Timer.h
OS/VAXConversion.h
OS/VAXDataConversion.h
DESTINATION include/casacore/casa/OS
)

install (FILES
Quanta/Euler.h
Quanta/MeasValue.h
Quanta/MVAngle.h
Quanta/MVBaseline.h
Quanta/MVDirection.h
Quanta/MVDoppler.h
Quanta/MVDouble.h
Quanta/MVEarthMagnetic.h
Quanta/MVEpoch.h
Quanta/MVFrequency.h
Quanta/MVPosition.h
Quanta/MVRadialVelocity.h
Quanta/MVTime.h
Quanta/MVuvw.h
Quanta/QBase.h
Quanta/QC.h
Quanta/QLogical.h
Quanta/QLogical.tcc
Quanta/QMath.h
Quanta/QMath.tcc
Quanta/Quantum.h
Quanta/Quantum.tcc
Quanta/QVector.h
Quanta/QVector.tcc
Quanta/QuantumHolder.h
Quanta/QuantumType.h
Quanta/RotMatrix.h
Quanta/UnitDim.h
Quanta/Unit.h
Quanta/UnitMap.h
Quanta/UnitName.h
Quanta/UnitVal.h
DESTINATION include/casacore/casa/Quanta
)

install (FILES
System/Aipsrc.h
System/AipsrcValue.h
System/AipsrcValue.tcc
System/AipsrcVector.h
System/AipsrcVector.tcc
System/AppInfo.h
System/AppState.h
System/Casarc.h
System/Choice.h
System/ObjectID.h
System/PGPlotter.h
System/PGPlotterInterface.h
System/PGPlotterNull.h
System/ProgressMeter.h
DESTINATION include/casacore/casa/System
)

install (FILES
Utilities/Assert.h
Utilities/Assert.tcc
Utilities/BinarySearch.h
Utilities/BinarySearch.tcc
Utilities/BitVector.h
Utilities/CASATask.h
Utilities/Compare.h
Utilities/Compare.tcc
Utilities/CompositeNumber.h
Utilities/Copy.h
Utilities/Copy.tcc
Utilities/CountedPtr.h
Utilities/CountedPtr.tcc
Utilities/COWPtr.h
Utilities/COWPtr.tcc
Utilities/DataType.h
Utilities/DefaultValue.h
Utilities/DynBuffer.h
Utilities/Fallible.h
Utilities/generic.h
Utilities/GenSort.h
Utilities/GenSort.tcc
Utilities/LinearSearch.h

=== coordinates/CMakeLists.txt ===
#
# CASA coordinates
#

add_library (casa_coordinates
Coordinates/Coordinate.cc
Coordinates/CoordinateSystem.cc
Coordinates/CoordinateUtil.cc
Coordinates/Direction2Coordinate.cc
Coordinates/DirectionCoordinate.cc
Coordinates/FITSCoordinateUtil.cc
Coordinates/GaussianConvert.cc
Coordinates/LinearCoordinate.cc
Coordinates/LinearXform2.cc
Coordinates/LinearXform.cc
Coordinates/ObsInfo.cc
Coordinates/Projection.cc
Coordinates/Spectral2Coordinate.cc
Coordinates/SpectralCoordinate.cc
Coordinates/QualityCoordinate.cc
Coordinates/StokesCoordinate.cc
Coordinates/TabularCoordinate.cc
)

set(top_level_headers
Coordinates.h
)

init_pch_support(casa_coordinates ${top_level_headers})

target_link_libraries (casa_coordinates casa_fits ${WCSLIB_LIBRARIES} ${CASACORE_ARCH_LIBS})

install (TARGETS casa_coordinates
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Coordinates/DirectionCoordinate.h
Coordinates/LinearXform.h
Coordinates/SpectralCoordinate.h
Coordinates/Coordinate.h
Coordinates/StokesCoordinate.h
Coordinates/QualityCoordinate.h
Coordinates/FITSCoordinateUtil.h
Coordinates/CoordinateSystem.h
Coordinates/FrequencyAligner.h
Coordinates/FrequencyAligner.tcc
Coordinates/Projection.h
Coordinates/ObsInfo.h
Coordinates/CoordinateUtil.h
Coordinates/GaussianConvert.h
Coordinates/LinearCoordinate.h
Coordinates/TabularCoordinate.h
DESTINATION include/casacore/coordinates/Coordinates
)

install (FILES ${top_level_headers}
DESTINATION include/casacore/coordinates
)

add_subdirectory (Coordinates/test ${EXCL_ALL})

=== derivedmscal/CMakeLists.txt ===
#
# CASA derivedmscal
#

add_library (casa_derivedmscal
DerivedMC/DerivedMSCal.cc
DerivedMC/DerivedColumn.cc
DerivedMC/MSCalEngine.cc
DerivedMC/Register.cc
DerivedMC/UDFMSCal.cc
)

set(top_level_headers
DerivedMC.h
)

init_pch_support(casa_derivedmscal ${top_level_headers})

target_link_libraries (casa_derivedmscal casa_ms ${CASACORE_ARCH_LIBS})

install (TARGETS casa_derivedmscal
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
DerivedMC/DerivedMSCal.h
DerivedMC/DerivedColumn.h
DerivedMC/MSCalEngine.h
DerivedMC/Register.h
DerivedMC/UDFMSCal.h
DESTINATION include/casacore/derivedmscal/DerivedMC
)

install (FILES ${top_level_headers}
DESTINATION include/casacore/derivedmscal
)

add_subdirectory (DerivedMC/test ${EXCL_ALL})

=== fits/CMakeLists.txt ===
#
# CASA Fits
#

add_library (casa_fits
FITS/FITSTimedTable.cc
FITS/FITSTable2.cc
FITS/CopyRecord.cc
FITS/FITSHistoryUtil.cc
FITS/FITSMultiTable.cc
FITS/hdu2.cc
FITS/FITSError.cc
FITS/FITSDateUtil.cc
FITS/FITSTable3.cc
FITS/SDFITSTable.cc
FITS/FITSTable.cc
FITS/fits.cc
FITS/BasicFITS.cc
FITS/FITSKeywordUtil.cc
FITS/FITSSpectralUtil.cc
FITS/fitsio.cc
FITS/BinTable.cc
FITS/blockio.cc
FITS/FITSReader.cc
)

set(top_level_headers
FITS.h
)

init_pch_support(casa_fits ${top_level_headers})

target_link_libraries (casa_fits casa_measures ${CFITSIO_LIBRARIES} ${CASACORE_ARCH_LIBS})

add_subdirectory (apps)

#the tests
add_subdirectory (FITS/test ${EXCL_ALL})

install (TARGETS casa_fits
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
FITS/BasicFITS.h
FITS/BinTable.h
FITS/blockio.h
FITS/CopyRecord.h
FITS/FITS2.h
FITS/FITS2.tcc
FITS/FITSDateUtil.h
FITS/FITSError.h
FITS/FITSFieldCopier.h
FITS/fits.h
FITS/FITSHistoryUtil.h
FITS/fitsio.h
FITS/FITSKeywordUtil.h
FITS/FITSMultiTable.h
FITS/FITSSpectralUtil.h
FITS/FITSTable.h
FITS/FITSTimedTable.h
FITS/hdu.h
FITS/hdu.tcc
FITS/SDFITSTable.h
FITS/FITSReader.h
DESTINATION include/casacore/fits/FITS
)

install (FILES ${top_level_headers}
DESTINATION include/casacore/fits
)

=== images/CMakeLists.txt ===
#
# CASA Images
#

if (BISON_VERSION VERSION_LESS 3.0)
    BISON_TARGET (ImageExprGram Images/ImageExprGram.yy ${CMAKE_CURRENT_BINARY_DIR}/ImageExprGram.ycc COMPILE_FLAGS "-p ImageExprGram")
else()
    BISON_TARGET (ImageExprGram Images/ImageExprGram.yy
    ${CMAKE_CURRENT_BINARY_DIR}/ImageExprGram.ycc COMPILE_FLAGS "-Dapi.prefix={ImageExprGram} --warnings=no-yacc")
endif()
FLEX_TARGET (ImageExprGram Images/ImageExprGram.ll ${CMAKE_CURRENT_BINARY_DIR}/ImageExprGram.lcc COMPILE_FLAGS "-PImageExprGram")

include_directories (${CMAKE_CURRENT_BINARY_DIR})

add_library (casa_images
Regions/WCEllipsoid.cc
Regions/RegionManager.cc
Regions/WCLELMask.cc
Regions/WCPolygon.cc
Regions/WCUnion.cc
Regions/WCRegion2.cc
Regions/RegionHandlerMemory.cc
Regions/WCExtension.cc
Regions/RegionHandlerTable.cc
Regions/WCCompound.cc
Regions/WCRegion.cc
Regions/WCIntersection.cc
Regions/WCConcatenation.cc
Regions/ImageRegion.cc
Regions/RFReaderWriter.cc
Regions/RegionHandler.cc
Regions/WCDifference.cc
Regions/WCBox.cc
Regions/AipsIOReaderWriter.cc
Regions/WCComplement.cc
Regions/RegionHandlerHDF5.cc
Images/FITSErrorImage.cc
Images/FITSImage.cc
Images/FITSImgParser.cc
Images/FITSQualityImage.cc
Images/FITSQualityMask.cc
Images/HDF5Image2.cc
Images/Image_tmpl.cc
Images/ImageAttrGroup.cc
Images/ImageAttrGroupCasa.cc
Images/ImageAttrGroupHDF5.cc
Images/ImageAttrHandler.cc
Images/ImageAttrHandlerCasa.cc
Images/ImageAttrHandlerHDF5.cc
Images/ImageBeamSet.cc
Images/ImageExprGram.cc
Images/ImageExprParse.cc
Images/ImageFITS2Converter.cc
Images/ImageInfo.cc
Images/ImageOpener.cc
Images/ImageProxy.cc
Images/ImageUtilities.cc
Images/LELImageCoord.cc
Images/MIRIADImage.cc
Images/MaskSpecifier.cc
Images/PagedImage2.cc
${BISON_ImageExprGram_OUTPUTS}
${FLEX_ImageExprGram_OUTPUTS}
)

set(top_level_headers
Regions.h
Images.h
)

init_pch_support(casa_images ${top_level_headers})

target_link_libraries (
casa_images
casa_coordinates
casa_mirlib
casa_lattices
${CASACORE_ARCH_LIBS}
)

add_subdirectory (apps)

install (
TARGETS casa_images
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Images/CurvedImage2D.h
Images/CurvedImage2D.tcc
Images/ExtendImage.h
Images/ExtendImage.tcc
Images/FITS2Image.tcc
Images/FITSErrorImage.h
Images/FITSImage.h
Images/FITSImgParser.h
Images/FITSQualityImage.h
Images/FITSQualityMask.h
Images/HDF5Image.h
Images/HDF5Image.tcc
Images/ImageAttrGroup.h
Images/ImageAttrGroupCasa.h
Images/ImageAttrGroupHDF5.h
Images/ImageAttrHandler.h
Images/ImageAttrHandlerCasa.h
Images/ImageAttrHandlerHDF5.h
Images/ImageBeamSet.h
Images/ImageConcat.h
Images/ImageConcat.tcc
Images/ImageExpr.h
Images/ImageExpr.tcc
Images/ImageExprGram.h
Images/ImageExprParse.h
Images/ImageFITSConverter.h
Images/ImageFITSConverter.tcc
Images/ImageInfo.h
Images/ImageInterface.h
Images/ImageInterface.tcc
Images/ImageOpener.h
Images/ImageProxy.h
Images/ImageRegrid.h
Images/ImageRegrid.tcc
Images/ImageStatistics.h
Images/ImageStatistics.tcc
Images/ImageSummary.h
Images/ImageSummary.tcc
Images/ImageUtilities.h
Images/ImageUtilities2.tcc
Images/LELImageCoord.h
Images/MIRIADImage.h
Images/MaskSpecifier.h
Images/PagedImage.h
Images/PagedImage.tcc
Images/RebinImage.h
Images/RebinImage.tcc
Images/SubImage.h
Images/SubImage.tcc
Images/TempImage.h
Images/TempImage.tcc
DESTINATION include/casacore/images/Images
)

install (FILES
Regions/AipsIOReaderWriter.h
Regions/ImageRegion.h
Regions/RegionHandler.h
Regions/RegionHandlerHDF5.h
Regions/RegionHandlerMemory.h
Regions/RegionHandlerTable.h
Regions/RegionManager.h
Regions/RFReaderWriter.h
Regions/WCBox.h
Regions/WCComplement.h
Regions/WCCompound.h
Regions/WCConcatenation.h
Regions/WCDifference.h
Regions/WCEllipsoid.h
Regions/WCExtension.h
Regions/WCIntersection.h
Regions/WCLELMask.h
Regions/WCPolygon.h
Regions/WCRegion.h
Regions/WCUnion.h
DESTINATION include/casacore/images/Regions
)

install (FILES ${top_level_headers}
DESTINATION include/casacore/images
)

add_subdirectory (Images/test ${EXCL_ALL})
add_subdirectory (Regions/test ${EXCL_ALL})

=== lattices/CMakeLists.txt ===
#
# CASA Lattices
#

add_library (casa_lattices
Lattices/Lattices_tmpl.cc
Lattices/LatticeBase.cc
Lattices/LatticeIndexer.cc
Lattices/LatticeLocker.cc
Lattices/LatticeNavigator.cc
Lattices/LatticeStepper.cc
Lattices/PixelCurve1D.cc
Lattices/TileStepper.cc
Lattices/TiledLineStepper.cc
Lattices/TiledShape.cc
LatticeMath/Fit2D.cc
LatticeMath/LatticeAddNoise.cc
LatticeMath/LatticeCleanProgress.cc
LatticeMath/LatticeFit.cc
LatticeMath/LatticeHistProgress.cc
LatticeMath/LatticeHistSpecialize.cc
LatticeMath/LatticeProgress.cc
LatticeMath/LatticeStatsBase.cc
LatticeMath/LattStatsProgress.cc
LatticeMath/LattStatsSpecialize.cc
LEL/LatticeExprNode.cc
LEL/LELArrayBase.cc
LEL/LELAttribute.cc
LEL/LELBinary2.cc
LEL/LELCoordinates.cc
LEL/LELFunction2.cc
LEL/LELLattCoord.cc
LEL/LELLattCoordBase.cc
LEL/LELRegion.cc
LEL/LELUnary2.cc
LRegions/FITSMask.cc
LRegions/LatticeRegion.cc
LRegions/LattRegionHolder.cc
LRegions/LCBox.cc
LRegions/LCComplement.cc
LRegions/LCConcatenation.cc
LRegions/LCDifference.cc
LRegions/LCEllipsoid.cc
LRegions/LCExtension.cc
LRegions/LCHDF5Mask.cc
LRegions/LCIntersection.cc
LRegions/LCLELMask.cc
LRegions/LCMask.cc
LRegions/LCPagedMask.cc
LRegions/LCPixelSet.cc
LRegions/LCPolygon.cc
LRegions/LCRegion.cc
LRegions/LCRegion2.cc
LRegions/LCRegionFixed.cc
LRegions/LCRegionMulti.cc
LRegions/LCRegionSingle.cc
LRegions/LCSlicer.cc
LRegions/LCStretch.cc
LRegions/LCUnion.cc
LRegions/RegionType.cc
)

set(top_level_headers
LatticeMath.h
Lattices.h
LEL.h
LRegions.h
)

init_pch_support(casa_lattices ${top_level_headers})

target_link_libraries (
casa_lattices
casa_tables
casa_scimath
${CASACORE_ARCH_LIBS}
)

install (TARGETS casa_lattices
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Lattices/ArrayLattice.h
Lattices/ArrayLattice.tcc
Lattices/CurvedLattice2D.h
Lattices/CurvedLattice2D.tcc
Lattices/ExtendLattice.h
Lattices/ExtendLattice.tcc
Lattices/HDF5LattIter.h
Lattices/HDF5LattIter.tcc
Lattices/HDF5Lattice.h
Lattices/HDF5Lattice.tcc
Lattices/Lattice.h
Lattices/Lattice.tcc
Lattices/LatticeBase.h
Lattices/LatticeCache.h
Lattices/LatticeCache.tcc
Lattices/LatticeConcat.h
Lattices/LatticeConcat.tcc
Lattices/LatticeIndexer.h
Lattices/LatticeIterInterface.h
Lattices/LatticeIterInterface.tcc
Lattices/LatticeIterator.h
Lattices/LatticeIterator.tcc
Lattices/LatticeLocker.h
Lattices/LatticeNavigator.h
Lattices/LatticeStepper.h
Lattices/LatticeUtilities.h
Lattices/LatticeUtilities.tcc
Lattices/MaskedLattice.h
Lattices/MaskedLattice.tcc
Lattices/MaskedLatticeIterator.h
Lattices/MaskedLatticeIterator.tcc
Lattices/PagedArrIter.h
Lattices/PagedArrIter.tcc
Lattices/PagedArray.h
Lattices/PagedArray.tcc
Lattices/PixelCurve1D.h
Lattices/RebinLattice.h
Lattices/RebinLattice.tcc
Lattices/SubLattice.h
Lattices/SubLattice.tcc
Lattices/TempLattice.h
Lattices/TempLattice.tcc
Lattices/TempLatticeImpl.h
Lattices/TempLatticeImpl.tcc
Lattices/TileStepper.h
Lattices/TiledLineStepper.h
Lattices/TiledShape.h
DESTINATION include/casacore/lattices/Lattices
)

install (FILES
LatticeMath/StatsTiledCollapser.h
LatticeMath/StatsTiledCollapser.tcc
LatticeMath/CLIPNearest2D.h
LatticeMath/CLIPNearest2D.tcc
LatticeMath/CLInterpolator2D.h
LatticeMath/CLInterpolator2D.tcc
LatticeMath/Fit2D.h
LatticeMath/Fit2D2.tcc
LatticeMath/LatticeAddNoise.h
LatticeMath/LatticeAddNoise2.tcc
LatticeMath/LatticeApply.h
LatticeMath/LatticeApply.tcc
LatticeMath/LatticeCleanProgress.h
LatticeMath/LatticeCleaner.h
LatticeMath/LatticeCleaner.tcc
LatticeMath/LatticeConvolver.h
LatticeMath/LatticeConvolver.tcc
LatticeMath/LatticeFFT.h
LatticeMath/LatticeFFT.tcc
LatticeMath/LatticeFit.h
LatticeMath/LatticeFractile.h
LatticeMath/LatticeFractile.tcc
LatticeMath/LatticeHistProgress.h
LatticeMath/LatticeHistSpecialize.h
LatticeMath/LatticeHistSpecialize2.tcc
LatticeMath/LatticeHistograms.h
LatticeMath/LatticeHistograms.tcc
LatticeMath/LatticeMathUtil.h
LatticeMath/LatticeMathUtil.tcc
LatticeMath/LatticeProgress.h
LatticeMath/LatticeSlice1D.h
LatticeMath/LatticeSlice1D.tcc
LatticeMath/LatticeStatistics.h
LatticeMath/LatticeStatistics.tcc
LatticeMath/LatticeStatsBase.h
LatticeMath/LatticeStatsDataProvider.h
LatticeMath/LatticeStatsDataProvider.tcc
LatticeMath/LatticeStatsDataProviderBase.h
LatticeMath/LatticeStatsDataProviderBase.tcc
LatticeMath/LatticeTwoPtCorr.h
LatticeMath/LatticeTwoPtCorr.tcc
LatticeMath/LattStatsProgress.h
LatticeMath/LattStatsSpecialize.h
LatticeMath/LattStatsSpecialize2.tcc
LatticeMath/LineCollapser.h
LatticeMath/LineCollapser.tcc
LatticeMath/MaskedLatticeStatsDataProvider.h
LatticeMath/MaskedLatticeStatsDataProvider.tcc
LatticeMath/MultiTermLatticeCleaner.h
LatticeMath/MultiTermLatticeCleaner.tcc
LatticeMath/TiledCollapser.h
LatticeMath/TiledCollapser.tcc
DESTINATION include/casacore/lattices/LatticeMath
)

install (FILES
LEL/LatticeExpr.h
LEL/LatticeExpr.tcc
LEL/LatticeExprNode.h
LEL/LELArray.h
LEL/LELArray.tcc
LEL/LELArrayBase.h
LEL/LELAttribute.h
LEL/LELBinary.h
LEL/LELBinary.tcc
LEL/LELBinaryEnums.h
LEL/LELCondition.h
LEL/LELCondition.tcc
LEL/LELConvert.h
LEL/LELConvert.tcc
LEL/LELCoordinates.h
LEL/LELFunction.h
LEL/LELFunction.tcc
LEL/LELFunctionEnums.h
LEL/LELInterface.h
LEL/LELInterface.tcc
LEL/LELLattCoord.h
LEL/LELLattCoordBase.h
LEL/LELLattice.h
LEL/LELLattice.tcc
LEL/LELRegion.h
LEL/LELScalar.h
LEL/LELScalar.tcc
LEL/LELSpectralIndex.h
LEL/LELSpectralIndex.tcc
LEL/LELUnary.h
LEL/LELUnary.tcc
LEL/LELUnaryEnums.h
DESTINATION include/casacore/lattices/LEL
)

install (FILES
LRegions/FITSMask.h
LRegions/LatticeRegion.h
LRegions/LattRegionHolder.h
LRegions/LCBox.h
LRegions/LCComplement.h
LRegions/LCConcatenation.h
LRegions/LCDifference.h
LRegions/LCEllipsoid.h
LRegions/LCExtension.h
LRegions/LCHDF5Mask.h
LRegions/LCIntersection.h
LRegions/LCLELMask.h
LRegions/LCMask.h
LRegions/LCPagedMask.h
LRegions/LCPixelSet.h
LRegions/LCPolygon.h
LRegions/LCRegion.h
LRegions/LCRegionFixed.h
LRegions/LCRegionMulti.h
LRegions/LCRegionSingle.h
LRegions/LCSlicer.h
LRegions/LCStretch.h
LRegions/LCUnion.h
LRegions/RegionType.h
DESTINATION include/casacore/lattices/LRegions
)

install (FILES ${top_level_headers}
DESTINATION include/casacore/lattices
)

# The tests
add_subdirectory (Lattices/test ${EXCL_ALL})
add_subdirectory (LatticeMath/test ${EXCL_ALL})
add_subdirectory (LEL/test ${EXCL_ALL})
add_subdirectory (LRegions/test ${EXCL_ALL})

=== measures/CMakeLists.txt ===
#
# CASA measures
#

# Check whether DATA_DIR contains data (only if measures is build)
get_filename_component(ABS_DATA_DIR "${DATA_DIR}" ABSOLUTE)
if (NOT EXISTS "${ABS_DATA_DIR}/ephemerides/")
    message(WARNING "No ephemerides data found in the specified DATA_DIR (\"${DATA_DIR}\"), so the location must be specified at runtime. If you have preinstalled casacore data, specify the location with -DDATA_DIR.")
endif()

# If given, add the data directory as compile variable.
# If it contains a single $, it needs to be doubled for make purposes.
if (DATA_DIR)
    string(REGEX REPLACE [$] $$ DATA_DIRX ${DATA_DIR})
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCASADATA='\"${DATA_DIRX}\"'")
endif (DATA_DIR)

add_library (casa_measures
Measures/Aberration.cc
Measures/EarthField.cc
Measures/EarthMagneticMachine.cc
Measures/MBaseline.cc
Measures/MCBase.cc
Measures/MCBaseline.cc
Measures/MCDirection.cc
Measures/MCDoppler.cc
Measures/MCEarthMagnetic.cc
Measures/MCEpoch.cc
Measures/MCFrame.cc
Measures/MCFrequency.cc
Measures/MConvertBase.cc
Measures/MCPosition.cc
Measures/MCRadialVelocity.cc
Measures/MCuvw.cc
Measures/MDirection.cc
Measures/MDoppler.cc
Measures/MEarthMagnetic.cc
Measures/MeasComet.cc
Measures/MeasData.cc
Measures/MeasFrame.cc
Measures/MeasIERS.cc
Measures/MeasJPL.cc
Measures/MeasMath.cc
Measures/MeasTable.cc
Measures/MeasTableMul.cc
Measures/Measure.cc
Measures/MeasureHolder.cc
Measures/MeasuresProxy.cc
Measures/MEpoch.cc
Measures/MFrequency.cc
Measures/MPosition.cc
Measures/MRadialVelocity.cc
Measures/MRBase.cc
Measures/Muvw.cc
Measures/Nutation.cc
Measures/ParAngleMachine.cc
Measures/Precession.cc
Measures/Quality.cc
Measures/SolarPos.cc
Measures/Stokes.cc
Measures/UVWMachine.cc
Measures/VelocityMachine.cc
TableMeasures/TableMeasColumn.cc
TableMeasures/TableMeasDescBase.cc
TableMeasures/TableMeasOffsetDesc.cc
TableMeasures/TableMeasRefDesc.cc
TableMeasures/TableMeasType.cc
TableMeasures/TableMeasValueDesc.cc
TableMeasures/TableQuantumDesc.cc
)

set (top_level_headers
Measures.h
TableMeasures.h
)

init_pch_support(casa_measures ${top_level_headers})

target_link_libraries (casa_measures casa_tables casa_scimath ${CASACORE_ARCH_LIBS})

add_subdirectory (apps)

install (
TARGETS casa_measures
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Measures/Aberration.h
Measures/EarthField.h
Measures/EarthMagneticMachine.h
Measures/MBaseline.h
Measures/MCBase.h
Measures/MCBaseline.h
Measures/MCDirection.h
Measures/MCDoppler.h
Measures/MCEarthMagnetic.h
Measures/MCEpoch.h
Measures/MCFrame.h
Measures/MCFrequency.h
Measures/MConvertBase.h
Measures/MCPosition.h
Measures/MCRadialVelocity.h
Measures/MCuvw.h
Measures/MDirection.h
Measures/MDoppler.h
Measures/MEarthMagnetic.h
Measures/MeasBase.h
Measures/MeasBase.tcc
Measures/MeasComet.h
Measures/MeasConvert.h
Measures/MeasConvert.tcc
Measures/MeasData.h
Measures/MeasFrame.h
Measures/MeasIERS.h
Measures/MeasJPL.h
Measures/MeasMath.h
Measures/MeasRef.h
Measures/MeasRef.tcc
Measures/MeasTable.h
Measures/MeasTableMul.h
Measures/Measure.h
Measures/MeasureHolder.h
Measures/MeasuresProxy.h
Measures/MEpoch.h
Measures/MFrequency.h
Measures/MPosition.h
Measures/MRadialVelocity.h
Measures/MRBase.h
Measures/Muvw.h
Measures/Nutation.h
Measures/ParAngleMachine.h
Measures/Precession.h
Measures/Quality.h
Measures/SolarPos.h
Measures/Stokes.h
Measures/UVWMachine.h
Measures/VelocityMachine.h
DESTINATION include/casacore/measures/Measures
)

install (FILES
TableMeasures/ArrayMeasColumn.h
TableMeasures/ArrayMeasColumn.tcc
TableMeasures/ArrayQuantColumn.h
TableMeasures/ArrayQuantColumn.tcc
TableMeasures/ScalarMeasColumn.h
TableMeasures/ScalarMeasColumn.tcc
TableMeasures/ScalarQuantColumn.h
TableMeasures/ScalarQuantColumn.tcc
TableMeasures/TableMeasColumn.h
TableMeasures/TableMeasDescBase.h
TableMeasures/TableMeasDesc.h
TableMeasures/TableMeasDesc.tcc
TableMeasures/TableMeasOffsetDesc.h
TableMeasures/TableMeasRefDesc.h
TableMeasures/TableMeasType.h
TableMeasures/TableMeasValueDesc.h
TableMeasures/TableQuantumDesc.h
DESTINATION include/casacore/measures/TableMeasures
)

install (FILES ${top_level_headers}
DESTINATION include/casacore/measures
)

add_subdirectory (Measures/test ${EXCL_ALL})
add_subdirectory (TableMeasures/test ${EXCL_ALL})

=== python/CMakeLists.txt ===
# It would be nice to use CMAKE_VERSION instead but that requires CMake 2.6.3
if(${CMAKE_MAJOR_VERSION} GREATER 3 OR
  (${CMAKE_MAJOR_VERSION} EQUAL 3 AND ${CMAKE_MINOR_VERSION} GREATER 13))
    include (${CMAKE_CURRENT_LIST_DIR}/CMakeLists-cmake3.14.txt)
else()
    include (${CMAKE_CURRENT_LIST_DIR}/CMakeLists-older-cmake.txt)
endif()

=== scimath/CMakeLists.txt ===
#
# CASA Scimath
#

set (buildfiles
Fitting/FittingProxy.cc
Fitting/LSQFit.cc
Fitting/LSQFit3.cc
Fitting/LSQMatrix2.cc
Fitting/LSQMatrix.cc
Functionals/FuncExpression.cc
Functionals/FuncExprData.cc
Functionals/FunctionFactoryErrors.cc
Functionals/FunctionalProxy.cc
Functionals/SerialHelper.cc
Mathematics/Combinatorics.cc
Mathematics/FFTServer.cc
Mathematics/FFTW.cc
Mathematics/GaussianBeam.cc
Mathematics/Geometry.cc
Mathematics/Interpolate2D.cc
Mathematics/MathFunc2.cc
Mathematics/MatrixSolver.cc
Mathematics/MedianSlider.cc
Mathematics/NNLSMatrixSolver.cc
Mathematics/NumericTraits.cc
Mathematics/RigidVector2.cc
Mathematics/SCSL.cc
Mathematics/SquareMatrix2.cc
Mathematics/VectorKernel.cc
Mathematics/VanVleck.cc
StatsFramework/BiweightStatisticsData.cc
StatsFramework/ClassicalStatisticsData.cc
StatsFramework/StatisticsData.cc
StatsFramework/ZScoreCalculator.cc
)

if (BUILD_FFTPACK_DEPRECATED)
    list (APPEND buildfiles
         Mathematics/FFTPack.cc
    )
    install (FILES
       Mathematics/FFTPack.h
       DESTINATION include/casacore/scimath/Mathematics
    )
endif ()

add_library (casa_scimath ${buildfiles})

set (top_level_headers
Fitting.h
Functionals.h
Mathematics.h
)

init_pch_support(casa_scimath ${top_level_headers})

if (FFTW3_FOUND)
    target_link_libraries (casa_scimath casa_scimath_f ${FFTW3_LIBRARIES} ${CASACORE_ARCH_LIBS})
else (FFTW3_FOUND)
    target_link_libraries (casa_scimath casa_scimath_f ${CASACORE_ARCH_LIBS})
endif (FFTW3_FOUND)

install (TARGETS casa_scimath
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_WRITE GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Fitting/FitGaussian.h
Fitting/FitGaussian.tcc
Fitting/FittingProxy.h
Fitting/GenericL2Fit.h
Fitting/GenericL2Fit.tcc
Fitting/LSQFit.h
Fitting/LSQFit2.tcc
Fitting/LSQMatrix.h
Fitting/LSQTraits.h
Fitting/LSQaips.h
Fitting/LSQaips.tcc
Fitting/LinearFit.h
Fitting/LinearFit.tcc
Fitting/LinearFitSVD.h
Fitting/LinearFitSVD.tcc
Fitting/NonLinearFit.h
Fitting/NonLinearFit.tcc
Fitting/NonLinearFitLM.h
Fitting/NonLinearFitLM.tcc
DESTINATION include/casacore/scimath/Fitting
)

install (FILES
Functionals/AbstractFunctionFactory.h
Functionals/ArraySampledFunctional.h
Functionals/ArraySampledFunctional.tcc
Functionals/Chebyshev.h
Functionals/Chebyshev.tcc
Functionals/ChebyshevParam.h
Functionals/ChebyshevParam.tcc
Functionals/Combi2Function.tcc
Functionals/CombiFunction.h
Functionals/CombiFunction.tcc
Functionals/CombiParam.h
Functionals/CombiParam.tcc
Functionals/CompiledFunction.h
Functionals/CompiledFunction.tcc
Functionals/CompiledParam.h
Functionals/CompiledParam.tcc
Functionals/Compound2Function.tcc
Functionals/CompoundFunction.h
Functionals/CompoundFunction.tcc
Functionals/CompoundParam.h
Functionals/CompoundParam.tcc
Functionals/ConstantND.h
Functionals/ConstantND.tcc
Functionals/ConstantNDParam.h
Functionals/ConstantNDParam.tcc
Functionals/DiracDFunction.h
Functionals/DiracDFunction.tcc
Functionals/DiracDParam.h
Functionals/DiracDParam.tcc
Functionals/EclecticFunctionFactory.h
Functionals/EclecticFunctionFactory.tcc
Functionals/EvenPolynomial.h
Functionals/EvenPolynomial.tcc
Functionals/EvenPolynomial2.tcc
Functionals/EvenPolynomialParam.h
Functionals/EvenPolynomialParam.tcc
Functionals/FuncExprData.h
Functionals/FuncExpression.h
Functionals/Function.h
Functionals/Function.tcc
Functionals/Function1D.h
Functionals/FunctionFactoryErrors.h
Functionals/FunctionHolder.h
Functionals/FunctionHolder.tcc
Functionals/FunctionMarshallable.h
Functionals/FunctionOrder.h
Functionals/FunctionOrder.tcc
Functionals/FunctionParam.h
Functionals/FunctionParam.tcc
Functionals/FunctionTraits.h
Functionals/FunctionWrapper.h
Functionals/FunctionWrapper.tcc
Functionals/FunctionalProxy.h
Functionals/GNoiseFunction.h
Functionals/GNoiseFunction.tcc
Functionals/GNoiseParam.h
Functionals/GNoiseParam.tcc
Functionals/Gaussian1D.h
Functionals/Gaussian1D.tcc
Functionals/Gaussian1D2.tcc
Functionals/Gaussian1DParam.h
Functionals/Gaussian1DParam.tcc
Functionals/Gaussian2D.h
Functionals/Gaussian2D.tcc
Functionals/Gaussian2D2.tcc
Functionals/Gaussian2DParam.h
Functionals/Gaussian2DParam.tcc
Functionals/Gaussian3D.h
Functionals/Gaussian3D.tcc
Functionals/Gaussian3D2.tcc
Functionals/Gaussian3DParam.h
Functionals/Gaussian3DParam.tcc
Functionals/GaussianND.h
Functionals/GaussianND.tcc
Functionals/GaussianNDParam.h
Functionals/GaussianNDParam.tcc
Functionals/HyperPlane.h
Functionals/HyperPlane.tcc
Functionals/HyperPlane2.tcc
Functionals/HyperPlaneParam.h
Functionals/HyperPlaneParam.tcc
Functionals/Interpolate1D.h
Functionals/Interpolate1D.tcc
Functionals/KaiserBFunction.h
Functionals/KaiserBFunction.tcc
Functionals/KaiserBParam.h
Functionals/KaiserBParam.tcc
Functionals/Lorentzian1D.h
Functionals/Lorentzian1D.tcc
Functionals/Lorentzian1D2.tcc
Functionals/Lorentzian1DParam.h
Functionals/Lorentzian1DParam.tcc
Functionals/MarshButterworthBandpass.h
Functionals/MarshButterworthBandpass.tcc
Functionals/MarshallableChebyshev.h
Functionals/MarshallableChebyshev.tcc
Functionals/OddPolynomial.h
Functionals/OddPolynomial.tcc
Functionals/OddPolynomial2.tcc
Functionals/OddPolynomialParam.h
Functionals/OddPolynomialParam.tcc
Functionals/PoissonFunction.h
Functionals/PoissonFunction.tcc
Functionals/PoissonFunction2.tcc
Functionals/PoissonParam.h
Functionals/PoissonParam.tcc
Functionals/Polynomial.h
Functionals/Polynomial.tcc
Functionals/Polynomial2.tcc
Functionals/PolynomialParam.h
Functionals/PolynomialParam.tcc
Functionals/PowerLogarithmicPolynomial.h
Functionals/PowerLogarithmicPolynomial.tcc
Functionals/PowerLogarithmicPolynomial2.tcc
Functionals/PowerLogarithmicPolynomialParam.h
Functionals/PowerLogarithmicPolynomialParam.tcc
Functionals/SPolynomial.h
Functionals/SPolynomial.tcc
Functionals/SPolynomialParam.h
Functionals/SPolynomialParam.tcc
Functionals/SampledFunctional.h
Functionals/ScalarSampledFunctional.h
Functionals/ScalarSampledFunctional.tcc
Functionals/SerialHelper.h
Functionals/SimButterworthBandpass.h
Functionals/SimButterworthBandpass.tcc
Functionals/SincFunction.h
Functionals/SincFunction.tcc
Functionals/SincParam.h
Functionals/SincParam.tcc
Functionals/Sinusoid1D.h
Functionals/Sinusoid1D.tcc
Functionals/Sinusoid1D2.tcc
Functionals/Sinusoid1DParam.h
Functionals/Sinusoid1DParam.tcc
Functionals/SpecificFunctionFactory.h
Functionals/UnaryFunction.h
Functionals/UnaryFunction.tcc
Functionals/UnaryParam.h
Functionals/UnaryParam.tcc
Functionals/WrapperBase.h
Functionals/WrapperData.h
Functionals/WrapperParam.h
Functionals/WrapperParam.tcc
DESTINATION include/casacore/scimath/Functionals
)

install (FILES
Mathematics/AutoDiff.h
Mathematics/AutoDiff.tcc
Mathematics/AutoDiffA.h
Mathematics/AutoDiffIO.h
Mathematics/AutoDiffIO.tcc
Mathematics/AutoDiffMath.h
Mathematics/AutoDiffMath.tcc
Mathematics/AutoDiffX.h
Mathematics/Combinatorics.h
Mathematics/ConvolveGridder.h
Mathematics/ConvolveGridder.tcc
Mathematics/Convolver.h
Mathematics/Convolver.tcc
Mathematics/DFTServer.h
Mathematics/DFTServer.tcc
Mathematics/FFTServer.h
Mathematics/FFTW.h
Mathematics/GaussianBeam.h
Mathematics/Geometry.h
Mathematics/Gridder.h
Mathematics/Gridder.tcc
Mathematics/HistAcc.h
Mathematics/HistAcc.tcc
Mathematics/Interpolate2D.h
Mathematics/Interpolate2D2.tcc
Mathematics/InterpolateArray1D.h
Mathematics/InterpolateArray1D.tcc
Mathematics/MathFunc.h
Mathematics/MathFunc.tcc
Mathematics/MatrixMathLA.h
Mathematics/MatrixMathLA.tcc
Mathematics/MatrixSolver.h
Mathematics/MedianSlider.h
Mathematics/NNGridder.h
Mathematics/NNGridder.tcc
Mathematics/NNLSMatrixSolver.h
Mathematics/NumericTraits.h
Mathematics/NumericTraits2.h
Mathematics/RigidVector.h
Mathematics/RigidVector.tcc
Mathematics/SCSL.h
Mathematics/Smooth.h
Mathematics/Smooth.tcc
Mathematics/SparseDiff.h
Mathematics/SparseDiff.tcc
Mathematics/SparseDiffA.h
Mathematics/SparseDiffIO.h
Mathematics/SparseDiffIO.tcc
Mathematics/SparseDiffMath.h
Mathematics/SparseDiffMath.tcc
Mathematics/SparseDiffRep.h
Mathematics/SparseDiffRep.tcc
Mathematics/SparseDiffX.h
Mathematics/SquareMatrix.h
Mathematics/SquareMatrix.tcc
Mathematics/StatAcc.h
Mathematics/StatAcc.tcc
Mathematics/VanVleck.h
Mathematics/VectorKernel.h
DESTINATION include/casacore/scimath/Mathematics
)

install (FILES
StatsFramework/BiweightStatistics.h
StatsFramework/BiweightStatistics.tcc
StatsFramework/BiweightStatisticsData.h
StatsFramework/ChauvenetCriterionStatistics.h
StatsFramework/ChauvenetCriterionStatistics.tcc
StatsFramework/ClassicalStatistics.h
StatsFramework/ClassicalStatistics.tcc
StatsFramework/ClassicalStatisticsData.h
StatsFramework/ClassicalQuantileComputer.h
StatsFramework/ClassicalQuantileComputer.tcc
StatsFramework/ConstrainedRangeStatistics.h
StatsFramework/ConstrainedRangeStatistics.tcc
StatsFramework/ConstrainedRangeQuantileComputer.h
StatsFramework/ConstrainedRangeQuantileComputer.tcc
StatsFramework/FitToHalfStatistics.h
StatsFramework/FitToHalfStatistics.tcc
StatsFramework/FitToHalfStatisticsData.h
StatsFramework/HingesFencesStatistics.h
StatsFramework/HingesFencesStatistics.tcc
StatsFramework/HingesFencesQuantileComputer.h
StatsFramework/HingesFencesQuantileComputer.tcc
StatsFramework/StatsDataProvider.h
StatsFramework/StatsDataProvider.tcc
StatsFramework/StatisticsAlgorithm.h
StatsFramework/StatisticsAlgorithm.tcc
StatsFramework/StatisticsAlgorithmFactory.h
StatsFramework/StatisticsAlgorithmFactory.tcc
StatsFramework/StatisticsAlgorithmFactoryData.h
StatsFramework/StatisticsAlgorithmQuantileComputer.h
StatsFramework/StatisticsAlgorithmQuantileComputer.tcc
StatsFramework/StatisticsData.h
StatsFramework/StatisticsDataset.h
StatsFramework/StatisticsDataset.tcc
StatsFramework/StatisticsIncrementer.h
StatsFramework/StatisticsTypes.h
StatsFramework/StatisticsTypes.tcc
StatsFramework/StatisticsUtilities.h
StatsFramework/StatisticsUtilities.tcc
StatsFramework/StatsHistogram.tcc
StatsFramework/StatsHistogram.h
StatsFramework/ZScoreCalculator.h
DESTINATION include/casacore/scimath/StatsFramework
)

install (FILES ${top_level_headers}
DESTINATION include/casacore/scimath
)

add_subdirectory (Fitting/test ${EXCL_ALL})
add_subdirectory (Functionals/test ${EXCL_ALL})
add_subdirectory (Mathematics/test ${EXCL_ALL})
add_subdirectory (StatsFramework/test ${EXCL_ALL})

=== tables/CMakeLists.txt ===
#
# CASA Tables
#

set (
parser_inputs
RecordGram
TableGram
)

# Note that in the future -Dapi.pure might need be added to the else branch,
# while %pure_parser should be removed from the .yy file.
foreach (src ${parser_inputs})
    if (BISON_VERSION VERSION_LESS 3.0)
        BISON_TARGET (${src} TaQL/${src}.yy
        ${CMAKE_CURRENT_BINARY_DIR}/${src}.ycc COMPILE_FLAGS "-y -p ${src}")
    else()
        BISON_TARGET (${src} TaQL/${src}.yy
        ${CMAKE_CURRENT_BINARY_DIR}/${src}.ycc COMPILE_FLAGS "-y -Dapi.prefix={${src}} --warnings=no-yacc")
    endif()
    FLEX_TARGET (${src} TaQL/${src}.ll ${CMAKE_CURRENT_BINARY_DIR}/${src}.lcc COMPILE_FLAGS "-P${src}")
endforeach (src)


include_directories (${CMAKE_CURRENT_BINARY_DIR})

# Add SOVERSION definition for files needing it.
foreach (src DataMan/DataManager.cc TaQL/UDFBase.cc)
    set_source_files_properties(${src}
                 PROPERTIES COMPILE_FLAGS -DSOVERSION=${LIB_SOVERSION})
endforeach (src)

if (ADIOS2_FOUND)
  set(ADIOS2_SOURCES DataMan/Adios2StMan.cc DataMan/Adios2StManColumn.cc)
  set(ADIOS2_HEADERS DataMan/Adios2StMan.h DataMan/Adios2StManColumn.h)
endif (ADIOS2_FOUND)

if(BUILD_DYSCO)
  add_subdirectory(Dysco)
else(BUILD_DYSCO)
  set(DYSCOSTMAN_SOURCES)
  set(DYSCOSTMAN_LIBRARIES)
endif(BUILD_DYSCO)

add_library (casa_tables
Tables/ArrayColumnBase.cc
Tables/ArrayColumn_tmpl.cc
Tables/ArrColData.cc
Tables/ArrColDesc.cc
Tables/ArrColDesc_tmpl.cc
Tables/BaseColDesc.cc
Tables/BaseColumn.cc
Tables/BaseTabIter.cc
Tables/BaseTable.cc
Tables/ColDescSet.cc
Tables/ColumnCache.cc
Tables/ColumnDesc.cc
Tables/ColumnSet.cc
Tables/ColumnsIndex.cc
Tables/ColumnsIndexArray.cc
Tables/ConcatColumn.cc
Tables/ConcatRows.cc
Tables/ConcatTable.cc
Tables/ExternalLockSync.cc
Tables/MemoryTable.cc
Tables/NullTable.cc
Tables/PlainColumn.cc
Tables/PlainTable.cc
Tables/ReadAsciiTable.cc
Tables/RefColumn.cc
Tables/RefRows.cc
Tables/RefTable.cc
Tables/RowCopier.cc
Tables/RowNumbers.cc
Tables/ScaColDesc_tmpl.cc
Tables/ScalarColumn_tmpl.cc
Tables/ScaRecordColData.cc
Tables/ScaRecordColDesc.cc
Tables/SetupNewTab.cc
Tables/StorageOption.cc
Tables/SubTabDesc.cc
Tables/TabPath.cc
Tables/Table.cc
Tables/TableAttr.cc
Tables/TableCache.cc
Tables/TableColumn.cc
Tables/TableCopy.cc
Tables/TableDesc.cc
Tables/TableError.cc
Tables/TableIndexProxy.cc
Tables/TableInfo.cc
Tables/TableIter.cc
Tables/TableIterProxy.cc
Tables/TableKeyword.cc
Tables/TableLock.cc
Tables/TableLockData.cc
Tables/TableLocker.cc
Tables/TableProxy.cc
Tables/TableRecord.cc
Tables/TableRecordRep.cc
Tables/TableRow.cc
Tables/TableRowProxy.cc
Tables/TableSyncData.cc
Tables/TableTrace.cc
Tables/TableUtil.cc
DataMan/BitFlagsEngine.cc
DataMan/CompressComplex.cc
DataMan/CompressFloat.cc
DataMan/DataManAccessor.cc
DataMan/DataManError.cc
DataMan/DataManInfo.cc
DataMan/DataManager.cc
DataMan/DataManagerColumn.cc
DataMan/ForwardCol.cc
DataMan/ForwardColRow.cc
DataMan/ISMBase.cc
DataMan/ISMBucket.cc
DataMan/ISMColumn.cc
DataMan/ISMIndColumn.cc
DataMan/ISMIndex.cc
DataMan/IncrStManAccessor.cc
DataMan/IncrementalStMan.cc
DataMan/MSMBase.cc
DataMan/MSMColumn.cc
DataMan/MSMDirColumn.cc
DataMan/MSMIndColumn.cc
DataMan/MemoryStMan.cc
DataMan/SSMBase.cc
DataMan/SSMColumn.cc
DataMan/SSMDirColumn.cc
DataMan/SSMIndColumn.cc
DataMan/SSMIndStringColumn.cc
DataMan/SSMIndex.cc
DataMan/SSMStringHandler.cc
DataMan/StArrAipsIO.cc
DataMan/StArrayFile.cc
DataMan/StIndArrAIO.cc
DataMan/StIndArray.cc
DataMan/StManAipsIO.cc
DataMan/StManColumn.cc
DataMan/StManColumnBase.cc
DataMan/StandardStMan.cc
DataMan/StandardStManAccessor.cc
DataMan/TSMColumn.cc
DataMan/TSMCoordColumn.cc
DataMan/TSMCube.cc
DataMan/TSMCubeBuff.cc
DataMan/TSMCubeMMap.cc
DataMan/TSMDataColumn.cc
DataMan/TSMFile.cc
DataMan/TSMIdColumn.cc
DataMan/TSMOption.cc
DataMan/TSMShape.cc
DataMan/TiledCellStMan.cc
DataMan/TiledColumnStMan.cc
DataMan/TiledDataStMan.cc
DataMan/TiledDataStManAccessor.cc
DataMan/TiledFileAccess.cc
DataMan/TiledFileHelper.cc
DataMan/TiledShapeStMan.cc
DataMan/TiledStMan.cc
DataMan/TiledStManAccessor.cc
DataMan/VirtArrCol.cc
DataMan/VirtScaCol.cc
DataMan/VirtColEng.cc
DataMan/VirtualTaQLColumn.cc
TaQL/ExprAggrNode.cc
TaQL/ExprAggrNodeArray.cc
TaQL/ExprConeNode.cc
TaQL/ExprDerNode.cc
TaQL/ExprDerNodeArray.cc
TaQL/ExprFuncNode.cc
TaQL/ExprFuncNodeArray.cc
TaQL/ExprGroup.cc
TaQL/ExprGroupAggrFunc.cc
TaQL/ExprGroupAggrFuncArray.cc
TaQL/ExprLogicNode.cc
TaQL/ExprLogicNodeArray.cc
TaQL/ExprMathNode.cc
TaQL/ExprMathNodeArray.cc
TaQL/ExprNode.cc
TaQL/ExprNodeArray.cc
TaQL/ExprNodeRecord.cc
TaQL/ExprNodeRep.cc
TaQL/ExprNodeSet.cc
TaQL/ExprNodeSetElem.cc
TaQL/ExprNodeSetOpt.cc
TaQL/ExprNodeUtil.cc
TaQL/ExprRange.cc
TaQL/ExprUDFNode.cc
TaQL/ExprUDFNodeArray.cc
TaQL/ExprUnitNode.cc
TaQL/MArrayBase.cc
TaQL/RecordExpr.cc
TaQL/RecordGram.cc
TaQL/TaQLJoin.cc
TaQL/TaQLNode.cc
TaQL/TaQLNodeDer.cc
TaQL/TaQLNodeHandler.cc
TaQL/TaQLNodeRep.cc
TaQL/TaQLNodeVisitor.cc
TaQL/TaQLResult.cc
TaQL/TaQLShow.cc
TaQL/TaQLStyle.cc
TaQL/TableExprData.cc
TaQL/TableExprId.cc
TaQL/TableGram.cc
TaQL/TableParse.cc
TaQL/TableParseFunc.cc
TaQL/TableParseGroupby.cc
TaQL/TableParseJoin.cc
TaQL/TableParseProject.cc
TaQL/TableParseQuery.cc
TaQL/TableParseSortKey.cc
TaQL/TableParseTableList.cc
TaQL/TableParseUpdate.cc
TaQL/TableParseUtil.cc
TaQL/UDFBase.cc
LogTables/TableLogSink.cc
LogTables/NewFile.cc
LogTables/LoggerHolder.cc
LogTables/LogFilterTaql.cc
LogTables/LogFilterExpr.cc
${BISON_RecordGram_OUTPUTS}
${FLEX_RecordGram_OUTPUTS}
${BISON_TableGram_OUTPUTS}
${FLEX_TableGram_OUTPUTS}
${ADIOS2_SOURCES}
${DYSCOSTMAN_SOURCES}
)

set(top_level_headers
DataMan.h
LogTables.h
Tables.h
TaQL.h
)

init_pch_support(casa_tables ${top_level_headers})

target_link_libraries (casa_tables casa_casa ${CASACORE_ARCH_LIBS} ${DYSCOSTMAN_LIBRARIES} ${CASACORE_ADIOS_LIBRARY} ${CASACORE_MPI_LIBRARY})

add_subdirectory (apps)

install (TARGETS casa_tables
RUNTIME DESTINATION bin
LIBRARY DESTINATION lib${LIB_SUFFIX}
ARCHIVE DESTINATION lib${LIB_SUFFIX}
LIBRARY PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

install (FILES
Tables/ArrColData.h
Tables/ArrColDesc.h
Tables/ArrColDesc.tcc
Tables/ArrayColumn.h
Tables/ArrayColumn.tcc
Tables/ArrayColumnBase.h
Tables/ArrayColumnFunc.h
Tables/BaseColDesc.h
Tables/BaseColumn.h
Tables/BaseTabIter.h
Tables/BaseTable.h
Tables/ColDescSet.h
Tables/ColumnCache.h
Tables/ColumnDesc.h
Tables/ColumnSet.h
Tables/ColumnsIndex.h
Tables/ColumnsIndexArray.h
Tables/ConcatColumn.h
Tables/ConcatRows.h
Tables/ConcatScalarColumn.h
Tables/ConcatScalarColumn.tcc
Tables/ConcatTable.h
Tables/ExternalLockSync.h
Tables/MemoryTable.h
Tables/NullTable.h
Tables/PlainColumn.h
Tables/PlainTable.h
Tables/ReadAsciiTable.h
Tables/RefColumn.h
Tables/RefRows.h
Tables/RefTable.h
Tables/RowCopier.h
Tables/RowNumbers.h
Tables/ScaColData.h
Tables/ScaColData.tcc
Tables/ScaColDesc.h
Tables/ScaColDesc.tcc
Tables/ScaRecordColData.h
Tables/ScaRecordColDesc.h
Tables/ScalarColumn.h
Tables/ScalarColumn.tcc
Tables/SetupNewTab.h
Tables/StorageOption.h
Tables/SubTabDesc.h
Tables/TVec.h
Tables/TVec.tcc
Tables/TVecLogic.h
Tables/TVecLogic.tcc
Tables/TVecMath.h
Tables/TVecMath.tcc
Tables/TVecScaCol.h
Tables/TVecScaCol.tcc
Tables/TVecTemp.h
Tables/TVecTemp.tcc
Tables/TabPath.h
Tables/TabVecLogic.h
Tables/TabVecLogic.tcc
Tables/TabVecMath.h
Tables/TabVecMath.tcc
Tables/Table.h
Tables/TableAttr.h
Tables/TableCache.h
Tables/TableColumn.h
Tables/TableCopy.h
Tables/TableCopy.tcc
Tables/TableDesc.h
Tables/TableError.h
Tables/TableIndexProxy.h
Tables/TableInfo.h
Tables/TableIter.h
Tables/TableIterProxy.h
Tables/TableKeyword.h
Tables/TableLock.h
Tables/TableLockData.h
Tables/TableLocker.h
Tables/TableProxy.h
Tables/TableRecord.h
Tables/TableRecordRep.h
Tables/TableRow.h
Tables/TableRowProxy.h
Tables/TableSyncData.h
Tables/TableTrace.h
Tables/TableUtil.h
Tables/TableVector.h
Tables/TableVector.tcc
DESTINATION include/casacore/tables/Tables
)

install (FILES
DataMan/BaseMappedArrayEngine.h
DataMan/BaseMappedArrayEngine.tcc
DataMan/BitFlagsEngine.h
DataMan/BitFlagsEngine.tcc
DataMan/CompressComplex.h
DataMan/CompressFloat.h
DataMan/DataManAccessor.h
DataMan/DataManError.h
DataMan/DataManInfo.h
DataMan/DataManager.h
DataMan/DataManagerColumn.h
DataMan/ForwardCol.h
DataMan/ForwardColRow.h
DataMan/ISMBase.h
DataMan/ISMBucket.h
DataMan/ISMColumn.h
DataMan/ISMIndColumn.h
DataMan/ISMIndex.h
DataMan/IncrStManAccessor.h
DataMan/IncrementalStMan.h
DataMan/MSMBase.h
DataMan/MSMColumn.h
DataMan/MSMDirColumn.h
DataMan/MSMIndColumn.h
DataMan/MappedArrayEngine.h
DataMan/MappedArrayEngine.tcc
DataMan/MemoryStMan.h
DataMan/RetypedArrayEngine.h
DataMan/RetypedArrayEngine.tcc
DataMan/RetypedArraySetGet.h
DataMan/RetypedArraySetGet.tcc
DataMan/SSMBase.h
DataMan/SSMColumn.h
DataMan/SSMDirColumn.h
DataMan/SSMIndColumn.h
DataMan/SSMIndStringColumn.h
DataMan/SSMIndex.h
DataMan/SSMStringHandler.h
DataMan/ScaledArrayEngine.h
DataMan/ScaledArrayEngine.tcc
DataMan/ScaledComplexData.h
DataMan/ScaledComplexData.tcc
DataMan/StArrAipsIO.h
DataMan/StArrayFile.h
DataMan/StIndArrAIO.h
DataMan/StIndArray.h
DataMan/StManAipsIO.h
DataMan/StManColumn.h
DataMan/StManColumnBase.h
DataMan/StandardStMan.h
DataMan/StandardStManAccessor.h
DataMan/TSMColumn.h
DataMan/TSMCoordColumn.h
DataMan/TSMCube.h
DataMan/TSMCubeBuff.h
DataMan/TSMCubeMMap.h
DataMan/TSMDataColumn.h
DataMan/TSMFile.h
DataMan/TSMIdColumn.h
DataMan/TSMOption.h
DataMan/TSMShape.h
DataMan/TiledCellStMan.h
DataMan/TiledColumnStMan.h
DataMan/TiledDataStMan.h
DataMan/TiledDataStManAccessor.h
DataMan/TiledFileAccess.h
DataMan/TiledFileHelper.h
DataMan/TiledShapeStMan.h
DataMan/TiledStMan.h
DataMan/TiledStManAccessor.h
DataMan/VACEngine.h
DataMan/VACEngine.tcc
DataMan/VSCEngine.h
DataMan/VSCEngine.tcc
DataMan/VirtArrCol.h
DataMan/VirtArrCol.tcc
DataMan/VirtColEng.h
DataMan/VirtScaCol.h
DataMan/VirtScaCol.tcc
DataMan/VirtualTaQLColumn.h
${ADIOS2_HEADERS}
DESTINATION include/casacore/tables/DataMan
)

install (FILES
TaQL/ExprAggrNode.h
TaQL/ExprAggrNodeArray.h
TaQL/ExprConeNode.h
TaQL/ExprDerNode.h
TaQL/ExprDerNodeArray.h
TaQL/ExprFuncNode.h
TaQL/ExprFuncNodeArray.h
TaQL/ExprGroup.h
TaQL/ExprGroupAggrFunc.h
TaQL/ExprGroupAggrFuncArray.h
TaQL/ExprLogicNode.h
TaQL/ExprLogicNodeArray.h
TaQL/ExprMathNode.h
TaQL/ExprMathNodeArray.h
TaQL/ExprNode.h
TaQL/ExprNodeArray.h
TaQL/ExprNodeRecord.h
TaQL/ExprNodeRep.h
TaQL/ExprNodeSet.h
TaQL/ExprNodeSetElem.h
TaQL/ExprNodeSetOpt.h
TaQL/ExprNodeUtil.h
TaQL/ExprRange.h
TaQL/ExprUDFNode.h
TaQL/ExprUDFNodeArray.h
TaQL/ExprUnitNode.h
TaQL/MArrayBase.h
TaQL/MArrayLogical.h
TaQL/MArrayMathBase.h
TaQL/MArrayMath.h
TaQL/MArrayUtil.h
TaQL/MArray.h
TaQL/RecordExpr.h
TaQL/RecordGram.h
TaQL/TaQLJoin.h
TaQL/TaQLNode.h
TaQL/TaQLNodeDer.h
TaQL/TaQLNodeHandler.h
TaQL/TaQLNodeRep.h
TaQL/TaQLNodeResult.h
TaQL/TaQLNodeVisitor.h
TaQL/TaQLResult.h
TaQL/TaQLShow.h
TaQL/TaQLStyle.h
TaQL/TableExprData.h
TaQL/TableExprId.h
TaQL/TableExprIdAggr.h
TaQL/TableGram.h
TaQL/TableParse.h
TaQL/TableParseFunc.h
TaQL/TableParseGroupby.h
TaQL/TableParseJoin.h
TaQL/TableParseProject.h
TaQL/TableParseQuery.h
TaQL/TableParseSortKey.h
TaQL/TableParseTableList.h
TaQL/TableParseUpdate.h
TaQL/TableParseUtil.h
TaQL/UDFBase.h
DESTINATION include/casacore/tables/TaQL
)

install (FILES
LogTables/LogFilterTaql.h
LogTables/LoggerHolder.h
LogTables/TableLogSink.h
LogTables/LogFilterExpr.h
LogTables/NewFile.h
DESTINATION include/casacore/tables/LogTables
)

install (FILES ${top_level_headers}
DESTINATION include/casacore/tables
)

add_subdirectory (Tables/test ${EXCL_ALL})
add_subdirectory (DataMan/test ${EXCL_ALL})
add_subdirectory (TaQL/test ${EXCL_ALL})
add_subdirectory (LogTables/test ${EXCL_ALL})

=== casa/apps/CMakeLists.txt ===
# Programs
foreach(prog casahdf5support)
    add_executable (${prog}  ${prog}.cc)
    add_pch_support(${prog})
    target_link_libraries (${prog} casa_casa)
    install(TARGETS ${prog} DESTINATION bin)
endforeach()

# Scripts
##foreach(prog countcode)
##   install(PROGRAMS ${prog} DESTINATION bin)
##endforeach()

=== debian/changelog ===
casacore (3.6.1-5) unstable; urgency=medium

  * Move doc/ removal to d/clean
  * Remove numpy detection by CMake (Closes: #1095333)
  * Add numpy ABI dependency to libcasa-python3-8

 -- Ole Streicher <olebole@debian.org>  Fri, 07 Feb 2025 14:21:00 +0100

casacore (3.6.1-4) unstable; urgency=medium

  [ Phil Wyett ]
  * Add 'd/clean' and insert appropriate files. (Closes: #1043905)

  [ Ole Streicher ]
  * Stop pinning of gcc-12 (Closes: #1092203)

 -- Ole Streicher <olebole@debian.org>  Mon, 06 Jan 2025 08:16:52 +0100

casacore (3.6.1-3) unstable; urgency=medium

  * Switch to unstable to start transition
  * Overwrite buggy package 3.6.1-1 in unstable. Closes: #1080049

 -- Ole Streicher <olebole@debian.org>  Fri, 30 Aug 2024 09:52:42 +0200

casacore (3.6.1-2) experimental; urgency=medium

  * Change SOVERSION from 7 to 8. Drop unneeded (t64) breaks/replaces
  * Switch to experimental to announce transition
  * Disable tests that fail on big endian platforms

 -- Ole Streicher <olebole@debian.org>  Thu, 29 Aug 2024 08:45:20 +0200

casacore (3.6.1-1) unstable; urgency=medium

  * New upstream version 3.6.1
  * Drop gcc compatibility patches: applied upstream
  * Drop kfreeBSD patches: kfreeBSD is not a port anymore

 -- Ole Streicher <olebole@debian.org>  Wed, 28 Aug 2024 08:57:32 +0200

casacore (3.5.0-5) unstable; urgency=medium

  * Resolve issues compiling mirlib with gcc 14 (Closes: #1074866)
  * Push Standards-Version to 4.7.0. No changes needed

 -- Ole Streicher <olebole@debian.org>  Mon, 29 Jul 2024 21:21:12 +0200

=== debian/control ===
Source: casacore
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Benda Xu <heroxbd@gentoo.org>,
           Ole Streicher <olebole@debian.org>
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5), bison,
               cmake,
               debhelper-compat (= 13),
               dh-python,
               doxygen,
               flex,
               gfortran,
               graphviz,
               libblas-dev,
               libboost-filesystem-dev,
               libboost-python-dev,
               libboost-system-dev,
               libboost-test-dev,
               libcfitsio-dev,
               libfftw3-dev,
               libgsl-dev,
               liblapack-dev,
               libncurses-dev,
               libreadline-dev,
               python3-dev,
               python3-numpy,
               python3-numpy-dev,
               wcslib-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-astro-team/casacore
Vcs-Git: https://salsa.debian.org/debian-astro-team/casacore.git
Homepage: https://casacore.github.io/casacore
Rules-Requires-Root: no

Package: casacore-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcasa-casa8 (= ${binary:Version}),
         libcasa-coordinates8 (= ${binary:Version}),
         libcasa-derivedmscal8 (= ${binary:Version}),
         libcasa-fits8 (= ${binary:Version}),
         libcasa-images8 (= ${binary:Version}),
         libcasa-lattices8 (= ${binary:Version}),
         libcasa-meas8 (= ${binary:Version}),
         libcasa-measures8 (= ${binary:Version}),
         libcasa-mirlib8 (= ${binary:Version}),
         libcasa-ms8 (= ${binary:Version}),
         libcasa-msfits8 (= ${binary:Version}),
         libcasa-python3-8 (= ${binary:Version}),
         libcasa-scimath-f8 (= ${binary:Version}),
         libcasa-scimath8 (= ${binary:Version}),
         libcasa-tables8 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA core library development files
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the files for application development.

Package: casacore-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Suggests: casacore-dev
Description: CASA core library (documentation)
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the API documentation.

Package: casacore-tools
Architecture: any
Depends: python3,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Tools built with CASA
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the tools built with CASA core:
 .
  * taql - query language for casacore tables
  * measuresdata - create data tables for measures
  * imageregrid, imagecalc, showtable, showtablelock, findmeastable,
    fits2table, imreorder, casahdf5support, msselect,  image2fits,
    imageslice, etc.

Package: libcasa-casa8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA core modules
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the Core modules: Multi-dimensional arrays, Quantities
 (values with physical units), OS and IO interface classes, Containers (from
 pre-STL era), Miscellaneous modules for exceptions, tasking interface,
 command line input, logging, STL wrappers, and basic math classes and
 functors.
 .
 Most of the code has been developed before STL came into existence, so
 several classes in modules Containers and Utilities are superseded by their
 STL counterparts. However, they are still used in some casacore
 code. Furthermore, some classes offer some extra functionality compared to
 STL.

Package: libcasa-scimath8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA basic mathematical modules
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the mathematical modules n-dimensional functionals,
 linear and non-linear fitting, and miscellaneous.

Package: libcasa-scimath-f8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA scimath F library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the Mathematical modules N-dim functionals,
 linear/non-linear fitting, and miscellaneous.

Package: libcasa-python3-8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends},
	 ${python3:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA Python bindings
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the Python 3 bindings.

Package: libcasa-tables8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA table system
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the database-like table system with advanced query
 language (TaQL).

Package: libcasa-measures8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: casacore-data
Pre-Depends: ${misc:Pre-Depends}
Description: CASA measures library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package implements measures (i.e. quantities with references frames) and
 their persistency. Examples are the Hour-angle and Declination of a source at
 a certain time and observatory; an Ra/Dec for a certain mean epoch; an
 apparent frequency at a certain time given in eV; a local sidereal time at an
 observatory. Measures can be converted from one reference frame to another
 (and this possibility is its main reason for existence).

Package: libcasa-lattices8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA lattice library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package implements memory- or disk-based N-dimensional arrays (lattices)
 with masking, regions, expressions, and math.

Package: libcasa-fits8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA FITS library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains a C++ interface to read and write FITS files.

Package: libcasa-ms8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA MeasurementSet library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the data format for visibility data as described in the
 MeasurementSet definition. The MeasurementSet is where all data are
 ultimately to be found in CASA.

Package: libcasa-derivedmscal8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA derived mscal library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains derived MeasurementSet quantities (like hourangle) that
 can be used as virtual table columns or as TaQL user defined functions.

Package: libcasa-msfits8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA msfits library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the mapping of MeasurementSets to/from FITS.

Package: libcasa-coordinates8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA coordinates library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package contains the implementation of coordinates for astronomical
 images.

Package: libcasa-images8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA image processing library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This package implements n-dimensional images with masks, coordinates, and
 history.

Package: libcasa-meas8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA functions handling measures
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and
 applications.
 .
 This module extends TaQL (the Table Query Language) with functions handling
 measures. Currently it can handle directions, epochs, and positions.

Package: libcasa-mirlib8
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: CASA mirlib library
 The casacore package contains the core libraries of the old
 AIPS++/CASA (Common Astronomy Software Applications) package. This
 split was made to get a better separation of core libraries and

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
ifeq ($(DEB_HOST_ARCH_CPU),i386)
    export DEB_CXXFLAGS_MAINT_APPEND = -ffloat-store
endif
ifeq ($(DEB_HOST_ARCH_OS),hurd)
    THREADS=OFF
else
    THREADS=ON
endif

%:
	dh $@ --buildsystem=cmake --with python3

override_dh_auto_configure:
	dh_auto_configure -- -Wno-dev \
                -DCMAKE_SKIP_INSTALL_RPATH=ON \
		-DUSE_THREADS=$(THREADS) -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
		-DDATA_DIR=/var/lib/casacore/data \
		-DUSE_FFTW3=ON \
		-DUSE_HDF5=OFF \
		-DBUILD_PYTHON=OFF -DBUILD_PYTHON3=ON \
		-DBUILD_TESTING=True \
		-DPYTHON3_EXECUTABLE=/usr/bin/${shell py3versions -d} \
		-DPYTHON3_LIBRARY=/usr/lib/$(DEB_HOST_MULTIARCH)/lib${shell py3versions -d}.so \
		-DPYTHON3_INCLUDE_DIR=/usr/include/${shell py3versions -d} \
		-DPYTHON3_NUMPY_INCLUDE_DIRS=/usr/lib/$(DEB_HOST_MULTIARCH)/python3-numpy/numpy/_core/include

execute_after_dh_auto_build:
	dh_numpy3 -p libcasa-python3-8

override_dh_auto_build-indep:
	doxygen doxygen.cfg
	rm -f doc/html/jquery.js

override_dh_auto_test-indep override_dh_auto_install-indep:

override_dh_auto_test-arch:
	HOME=$(CURDIR) dh_auto_test --max-parallel=1 -a
